/*----------------------------------------------------------------------*/
/*  Shisaku Kentou 2 for V720S RFID module sample program for V720 Lib. */
/*  Author : Makoto Katsukura  -> Renewal : Hyunjong Kim                */
/*  DATE   : 2004/11/18(1st)   ->           2006/11/16(2nd)             */
/* 										    */
/* -> Date : 2007/10/13 Renewal : Jumpei Nishizaki 			    */
/*										    */
/* vOSĂ𗝉Kv͂܂BŜƒ߂	    */
/* ǂ̊֐ŉsĂ邩cxō\܂B        */
/* RFIDSS2łƂĂdvȖڂʂ܂B쌟ł̎g        */
/* 𗝉Ă                                                   */
/*----------------------------------------------------------------------*/

/*

    Pragma Instructions                                             

*/

#include <string.h>
#include "sfr26.h"
#include "v720s.h"
#include "sleep.h"
#include "LCDfunc.h"
#include "nosprintf.h"

/* BANK */
#define V720S_BANK_00H 0x00
#define V720S_BANK_01H 0x01

// vg^Cv錾
//gȂ֐ɂĂLqKv
void ta1int( void );				//^C}[A1݊֐
void ta2int( void );				//^C}[A2݊֐
void ta3int( void );				//^C}[A3݊֐
void ta4int( void );				//^C}[A4݊֐
void tb0int( void );				//^C}[B0݊֐
void tb1int( void );				//^C}[B1݊֐
void tb2int( void );				//^C}[B2݊֐
void adint( void );			        //ADϊ݊֐
void int0int( void );				//O0֐
void int1int( void );				//O1֐
void int3int( void );				//O3֐
void int4int( void );				//O4֐
void int5int( void );				//O5֐
void uart0traint( void );			//uart0M荞
void uart0recint( void );			//uart0M荞
void uart1traint( void );			//uart1M荞
void uart1recint( void );			//uart1M荞


//荞݂̐錾
//gȂ荞݂LqKv
#pragma INTERRUPT ta0int
#pragma INTERRUPT ta1int
#pragma INTERRUPT ta2int
#pragma INTERRUPT ta3int
#pragma INTERRUPT ta4int
#pragma INTERRUPT tb0int
#pragma INTERRUPT tb1int
#pragma INTERRUPT tb2int
#pragma INTERRUPT adint
#pragma INTERRUPT int0int
#pragma INTERRUPT int1int
#pragma INTERRUPT int3int
#pragma INTERRUPT int4int
#pragma INTERRUPT int5int
#pragma INTERRUPT uart0recint
#pragma INTERRUPT uart0traint
#pragma INTERRUPT uart1recint
#pragma INTERRUPT uart1traint


/* RFIDW[̃f[^M̊m点tO
   (uart2_received)g߂ɂ͏Ă*/
extern unsigned char uart2_received;

/* R}hoĂv720s_getdatao܂1ŁCȊO0D
   v720s_busy=0̎̓R}h󂯕tĂ*/
extern unsigned int v720s_busy;

/*fobK̃EHb`XgŊmF邽߂ɂ́C
  O[oϐƂĒ`ȂƑςł*/  
unsigned char mode = 0;
int time_count = 20; /*̃R}h܂ł̎ԐݒCdefault2b*/

/*
--------------------IȃǗ̂------------------------

V720S͈x̏ݖ߂ōő64ނƂł܂B
Ŏ쌟ƂĂ͍ő啶߂悤ɐݒƂȂ
message[64],rfid_data[64]̂̃g܂B

ۂɂ̓t[Xy[X64SgƂ͂ȂƎv܂̂
gƂɂmessage̕ϐ̑傫𒲐ĂB
ǉƂRFID^Oɏ݂ȂAʒu񂾂ǂޏꍇ
ݓei[message̕ϐ͕Kvł͂Ȃ
ǂݍ񂾓ei[ϐrfid_data[4]ݒ肷
̐ߖ񂪂ł܂B
܂ǂݍރf[^̓y[WPʂ̕Ȃ̂
1y[W4A܂rfid_data̔z4̔{ɂȂKv܂B
rfid_data[4, 8, 12, 16 ....]B
̍ŌɂNULL='\0'K邱Ƃɒ
--------------------------------------------------------------------
*/
unsigned char message00[64]; /*oN00HbZ[W*/
unsigned char message01[64]; /*oN01HbZ[W*/

void main(void)
{
  unsigned char rfid_data[64]; /*rfidMf[^i[ϐ*/
  unsigned char debug[80];

  /* ϐ錾 @*/
  
  /* eG[R[hi[p̕ϐ */
  int init_error_code;
  int send_error_code;
  int receive_error_code;
  
  int count=0;
  unsigned char mode=0x00;
  
  unsigned char send_flag = 0;

  LCD_init();
  LCD_cls();

  pd10 = 0x0f;					// gOXCb`̐ݒ

  /* ^C}̐ݒ */
  /* gp^C}TA0
     ڍׂ̓n[hEFA}jAmFĂD
  */
  udf = 0x00; /* _EJEgɐݒ */
  
  /* ^C}[A0[hWX^*/	
  ta0mr = 0x80;  
  
  /* ^C}l̏ _EJEgȂ̂ŁD*/
  ta0 = 62500-1;
  
  /* ^C}荞݂̐ݒ*/
  ta0ic = 0x06;
  
  /*^C}X^[g */
  tabsr |= 0x01;
  
  /* 荞݋ */
  _asm( "\tFSET I");  /* Enable interrupt */
  
  /*  */
  init_error_code = v720s_init();
  
  /* ރbZ[W̏ */
  /* ̃Rs[́CCł́CZq = gĂł܂ */
  /* strcpy(), strcat()Ȃǂ̊֐悤܂D*/
  /* C̏ڍׂɂẮCēc搶̃y[WɎg₷łD */
  /* http://www.bohyoh.com/  */
  
  
  /*̓t[Xy[Xɏޕmessageϐɓ܂D*/
  /*Rɕςďݖ߂oC
    ǂݎR}hgĊmFĂ*/
  strcpy(message00, "R:3>1>2 D:029cm ");
  strcpy(message01, "R:1>2>3 D:500cm ");

  /* ̎쌟ł́C(time_count/10)bɈC
     AăR}h𑗐M܂ */
  /*  send_flag ͂̂߂̂̂łD*/
  send_flag = 1;
  
  while(1)
    {
      /*---------------瑗R}h̑I-------------------*/
/////////////////////////////////////////////////////////////////////////////
//  Control{[h̃gOXCb`؂ւ邱ƂŗlXȃR}h        //
//  W[ɏo܂D						             //
//  ̃TvvOŎgpgOXCb`Control{[h        //
//  SW_DASW_CASW_BłBXCb`ƃR}h̑Ή͎̒ʂ               //
//-------------------------------------------------------------------------//
// SW_D     SW_C     SW_B     Mode     Command			             //
// @@@@@@@       0x00     oN00hmessage00̓e//
//                      0x20@@ oN01hmessage01̓e//
//                      0x40@@ oN00h̃f[^ǂݏo         //
//                      0x60@ @oN01h̃f[^ǂݏo         //
//                      0x80@@ ^OŗL̃VAio[ǂݏo//
//                      0xa0@@ XgbvR}h                    //
/////////////////////////////////////////////////////////////////////////////

      mode = p10&0xE0;
      
    if( send_flag && ( (mode==0xA0) || (v720s_busy==0) ) )
	{
	  
	  switch(mode)
	    {
	    case 0x00: /*oN00hɏ*/
	      send_error_code = v720s_putcmd_write(V720S_MODE_ST,V720S_BANK_00H,0,message00);
	      break;
	    case 0x20: /*oN01hɏ*/
	      send_error_code = v720s_putcmd_write(V720S_MODE_ST,V720S_BANK_01H,0,message01);
	      break;
	    case 0x40: /*oN00h̓ǂݍ*/
	      send_error_code = v720s_putcmd_read(V720S_MODE_ST,V720S_BANK_00H,0,3);
	      break;
	    case 0x60: /*oN01h̓ǂݍ*/
	      send_error_code = v720s_putcmd_read(V720S_MODE_ST,V720S_BANK_01H,0,3);
	      break;
	    case 0x80: /*VAio[̓ǂݍ*/
		send_error_code = v720s_putcmd_serial(V720S_MODE_ST);
		break;   
	    case 0xa0:/*RepeatR}h~CFIFO̔M~*/
	      send_error_code = v720s_putcmd_stop();
	      break;
	    default:
	      break;
	    }
	  
	  /*ꂼLib.̊֐͎̈QlĂD
	    ŌM[h̑IƂdefault
	    @V720S_MODE_STSingle TriggerƂȂĂ܂D
	    ʂ4̃R}hĂ݂āC
	    @V720S_MODE_STV720S_MODE_FT(FIFO Trigger)ɕς
	    SingleƂ7Ⴄ_𒲂ׂĂD*/
	  /*쌟ƂĂSingle&FIFO Trigger[h̎ƂȂ܂C
	    RFIDW[g\̔ǂ͕KAuto,Repeat[hC
	    V720S_MODE_FR(FIFO Repeat)[h͂Ă݂ĂD*/
	  send_flag = 0;
	}
      
      /*uart2_received ́Cuart2Cu񋟂O[oϐŁC
	gp邽߂ɂ́C\[X̐擪 #extern int uart2_received 
	ĂB̕Ő錾ĂƎv܂B
	[hCgW[̃f[^ƁC
	ꂪPɂȂ܂B\ԁiő0.1b炢ĵŁC
	main[v̒ŁCĎĂĂ */
      /*܂CʂM܂ł͑MȂ悤ɁC
	send_flagȂǂŊǗ悤ɂĂ 
	ȉꍇ́C쌟Ȃ̂ŁCƂ͂Ă܂j*/
      /* v720s_getdata(rfid_data) rfid_data ́@char^̔złD
	 KCz񐔂65ȏłȂƂ܂*/
      /* 悭킩ȂƂ́CKK₵ĂD */      
      
	if(uart2_received)//X|XM
	{
	  receive_error_code = v720s_getdata(rfid_data);
	  /* ĂԂƁCdata̒ɁCf[^i[Ă܂D */
	  strcpy(debug,"se=0000 re=0000 ");
	  exc_itoa(&debug[6],send_error_code);
	  exc_itoa(&debug[14],receive_error_code);

	/* ǂݍ񂾃f[^̂܂܏o͂ */
	  strcat(debug,rfid_data);

	/* Q[g̏Ԃ⋗𒊏oɂ͂gƕ֗ */
	/* łȂǂƂ0o͂̂Œ*/
	//  strcat(debug,"NextGate:");
	//  itoa_cat(debug,atoi(&rfid_data[10]),3);

	/* LCDɏo͂ */
	  LCD_cls();
	  LCD_locate(0,0,0,0);
	  LCD_print_str(debug);
	}
      
      count ++;
      
      /* (time_count/10)bɈ񑗐M */
      if(count > time_count)
	{
	  count = 0;
	  send_flag = 1;
	}
      
      /* ҂ */
      /* A^CvO~O̊{I*/
      sleep();
    }
}




/*  荞݊֌W̊֐   */
/*  eCgƂɂ悭ǂł */ 

void ta0int()
{
  /* ł̓WX^̓ǂݍ݈ȊÔƂ͂Ȃ  */
  /* uWX^v=u}CR̓o(I/O)𒼐ڑ삷vƂ*/
  /* LƃWX^̑̂ */  
  /* main [vɖ߂čĂsleep */
  sleep_flag = 0;

}
void ta1int( void ) {}
void ta2int( void ) {}
void ta3int( void ) {}
void ta4int( void ) {}
void tb0int( void ) {}
void tb1int( void ) {}
void tb2int( void ) {}
void adint( void ) {}
void int0int( void ) {}
void int1int( void ) {}
void int3int( void ) {}
void int4int( void ) {}
void int5int( void ) {}
void uart0traint( void ){}
void uart0recint( void ){}
void uart1traint( void ){}
void uart1recint( void ){}



